<?php

namespace App\Services\Customer;

use App\Services\CommonService;
use CodeIgniter\HTTP\IncomingRequest;

use App\Services\Customer\ClientService;

abstract class CustomerService extends CommonService
{
    private ?ClientService $_clientService = null;
    protected function __construct(?IncomingRequest $request = null)
    {
        parent::__construct($request);
        $this->addClassName('Customer');
    }
    final public function getClientService(): ClientService
    {
        if (!$this->_clientService) {
            $this->_clientService = new ClientService($this->request);
        }
        return $this->_clientService;
    }
}
